/******************************************************************************
*                       (c)2024 shotech Steffen Hofmann                        *
*                           D-22525 Hamburg                                    *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Date of the 1st version  :  10.12.2024
*  Devices Designation      :  VLCD Adapter
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*  Headerfile
*  ----------
*  For general things of the project
*
*******************************************************************************/

/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef HW_H
#define	HW_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include "types.h"
// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
    <p><b>Function prototype:</b></p>
  
    <p><b>Summary:</b></p>

    <p><b>Description:</b></p>

    <p><b>Precondition:</b></p>

    <p><b>Parameters:</b></p>

    <p><b>Returns:</b></p>

    <p><b>Example:</b></p>
    <code>
 
    </code>

    <p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

//- Timings -------------------------------------------------------------------
/*
// CPU clock speed    
#define F_CPU          14756000               		// 14.7456MHz processor
#define CRYSTAL_STR    "14.745600 MHz\r"
//- Teiler DIV64    
#define Timer_OCR_10ms   2304 //-- 14.7456 MHz Quarz
#define Timer_OCR_1ms    230 //reload counter value
*/  

//#define F_CPU          4000000UL  //- 4MHz
//#define F_CPU          18432000UL               		// 18.4320MHz processor
#define F_CPU          24000000UL               		// 18.4320MHz processor
#define CRYSTAL_STR    "18.432000 MHz\r"
//- Teiler DIV64    
#define Timer_OCR_10ms   2880 //-- 18.4320 MHz Quarz
#define Timer_OCR_1ms    288 //reload counter value
    
    
#define TIMER0_STOP()   (TCA0.SINGLE.CTRLA &= ~TCA_SINGLE_ENABLE_bm)
//- Ports und Pins ------------------------------------------------------------

//- Port A
#define A_XTAL1                 PIN0      // - Quarz
#define A_XTAL2                 PIN1      // - Quarz
#define A_FREE2                 PIN2      // - TCB0
#define A_FREE3                 PIN3      // - TCB1
#define A_MOSI                  PIN4      //          
#define A_MISO                  PIN5      //         
#define A_SCK                   PIN6      //
#define A_CS                    PIN7      //
//- Port C
#define C_TXD                   PIN0      // 
#define C_RXD                   PIN1      // 
#define C_SDA                   PIN2      // - I2C
#define C_SCL                   PIN3      // - I2C
//- Port D
#define D_PWM                   PIN1      // - TCA1
#define D_FREE2                 PIN2      // - 
#define D_FREE3                 PIN3      // - 
#define D_EN_BL                 PIN4      // - Enable Backlight
#define D_A0                    PIN5      // -
#define D_RST_LCD               PIN7      // - Reset LCD   
//- Port F
#define F_PHOTO_TRANS           PIN0      // - Fototransistor optional
#define F_FREE_1                PIN1
#define F_RST                   PIN6      //- Reset MCU

#define VLCD_CS_HIGH()          PORTA.OUT |= BIT(A_CS) 
#define VLCD_CS_LOW()           PORTA.OUT &= ~BIT(A_CS)

#define A0_HIGH()               PORTD.OUT |= BIT(D_A0) 
#define A0_LOW()                PORTD.OUT &= ~BIT(D_A0) 

#define BL_HIGH()               PORTD.OUT |= BIT(D_EN_BL) 
#define BL_LOW()                PORTD.OUT &= ~BIT(D_EN_BL)

#define RST_LCD_HIGH()          PORTD.OUT |= BIT(D_RST_LCD) 
#define RST_LCD_LOW()           PORTD.OUT &= ~BIT(D_RST_LCD)    

//- Ports
#define I2C_PORT                PORTC    
#define ADR_AHT_20              0x38 // 7-bit I2C device address  ( 0x70 8Bit )   //- Temp und Luftfeuchte

//- Gray Scale for Display
//#define GRAY_SCALE              
        
#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

