
/*******************************************************************************
*                       (c)2019 shotech Steffen Hofmann                        *
*                           D-22399 Hamburg                                    *
********************************************************************************
*  $Source: /home/CVS/,v $
*------------------------------------------------------------------------------*
*  Datum der 1. Version  :  05.01.2019
*  Geraete Bezeichnung   :  EPROM-EMU-USB
*------------------------------------------------------------------------------*
*- $Id:  $
*------------------------------------------------------------------------------*
*
*	Headerfile
*	----------
*	ports
*
******************************************************************************/

#include "ports.h"
#include "hw.h"
#include "types.h"

/*
Table 13-1. Port Pin Configurations
 DDxn | PORTxn |  PUD (in MCUCR) | I/O Pull-up Comment
 --------------------------------------------------
  0   |  0     |  X              | Input No Tri-state (Hi-Z)
  0   |  1     |  0              | Input Yes Pxn will source current if ext. pulled low.
  0   |  1     |  1              | Input No Tri-state (Hi-Z)
  1   |  0     |  X              | Output No Output Low (Sink)
  1   |  1     |  X              | Output No Output High (Source)
*/

void init_ports( void )
{
	//- Output
	PORTA.DIR = BIT(A_CS);
    PORTC.DIR = BIT(C_TXD) | BIT(C_SCL);
    PORTD.DIR = BIT(D_PWM) | BIT(D_EN_BL) | BIT(D_A0) | BIT(D_RST_LCD);
  
    
    VLCD_CS_HIGH();
    A0_HIGH();
    BL_HIGH();
    RST_LCD_HIGH();
    
    
	
}

