/******************************************************************************
*                       (c)2024 shotech Steffen Hofmann                        *
*                           D-22525 Hamburg                                    *
*******************************************************************************
*  $Source: $
*-----------------------------------------------------------------------------*
*  Date of the 1st version  :  10.12.2024
*  Devices Designation      :  VLCD Adapter
*-----------------------------------------------------------------------------*
*- $Id: $
*-----------------------------------------------------------------------------*
*
*  Headerfile
*  ----------
*  For general things of the project
*
*******************************************************************************/
#ifndef TYPES_H
#define TYPES_H

//allgemeine Define's *********************************************************

//- Datentypen ----------------------------------------------------------------


//#ifndef __WIN32__
//typedef unsigned char BOOL;
//#endif



#ifndef NULL
#define NULL    (0)
#endif

#ifndef EOF
#define EOF     (-1)
#endif

typedef enum {FALSE = 0, TRUE = !FALSE} BOOL;

#define LOW(x)  ((short)x & 0x0FF)
#define HIGH(x) ((short)x >> 8)
#define BSW(x)	((((x) >> 8) & 0x00FF) | (((x) << 8) & 0xFF00))
#define _SWAP_BYTE(x)  ((((x&0xf0)>>4)|((x&0x0f)<<4)));

//((tAscii&0xf0)>>4)|((tAscii&0x0f)<<4);

#define MINIMUM(x,y) ((x<y) ? x : y)
#define MAXIMUM(x,y) ((x>y) ? x : y)

/* Exported macro ------------------------------------------------------------*/
/* Common routines */
#define IS_AF(c)  ((c >= 'A') && (c <= 'F'))
#define IS_af(c)  ((c >= 'a') && (c <= 'f'))
#define IS_09(c)  ((c >= '0') && (c <= '9'))
#define ISVALIDHEX(c)  IS_AF(c) || IS_af(c) || IS_09(c)
#define ISVALIDDEC(c)  IS_09(c)
#define CONVERTDEC(c)  (c - '0')

#define CONVERTHEX_alpha(c)  (IS_AF(c) ? (c - 'A'+10) : (c - 'a'+10))
#define CONVERTHEX(c)   (IS_09(c) ? (c - '0') : CONVERTHEX_alpha(c))
	
typedef enum {
   ON,                      // switch on
   OFF                      // switch off
   } eswitch;

/* Exported types ------------------------------------------------------------*/
typedef signed long  s32;
typedef signed short s16;
typedef signed char  s8;

typedef signed long  const sc32;  /* Read Only */
typedef signed short const sc16;  /* Read Only */
typedef signed char  const sc8;   /* Read Only */

typedef volatile signed long  vs32;
typedef volatile signed short vs16;
typedef volatile signed char  vs8;

typedef volatile signed long  const vsc32;  /* Read Only */
typedef volatile signed short const vsc16;  /* Read Only */
typedef volatile signed char  const vsc8;   /* Read Only */

typedef unsigned long  u32;
typedef unsigned short u16;
typedef unsigned char  u8;

typedef unsigned long  const uc32;  /* Read Only */
typedef unsigned short const uc16;  /* Read Only */
typedef unsigned char  const uc8;   /* Read Only */

typedef volatile unsigned long  vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char  vu8;

typedef volatile unsigned long  const vuc32;  /* Read Only */
typedef volatile unsigned short const vuc16;  /* Read Only */
typedef volatile unsigned char  const vuc8;   /* Read Only */

typedef unsigned char BYTE;	//   Type BYTE definition

//typedef unsigned char uint8_t;
//typedef unsigned short uint16_t;
typedef signed char int8_t;
typedef unsigned long uint32_t;

/* enable global interrupts */
#define GIE      	        	   (SREG |= BIT(7))

/* disable global interrupts */
#define GID       	         	   (SREG &= ~BIT(7))

#define SLEEP()	asm("sleep")

#ifndef BV
  #define BV(x) (1 << (x))
#endif

typedef enum {RESET = 0, SET = !RESET} FlagStatus, ITStatus;

/* enables an unsigned char to be used as a series of booleans */
#define BIT(x)	           (1 << (x))
/* Set and clear bits in I/O registers can also be declared as macros */
#define SETBIT(ADDRESS,S_BIT)   (ADDRESS |= (1<<S_BIT))
#define CLEARBIT(ADDRESS,S_BIT) (ADDRESS &= ~(1<<S_BIT))
/* Macro for testing of a single bit in an I/O location*/
#define CHECKBIT(ADDRESS,S_BIT) (ADDRESS & (1<<S_BIT))


#endif
