/* 
 * File:   ugui_S1D15721.h
 * Author: Steffen Hofmann
 *
 * Created on 15. Dezember 2024, 01:04
 */

#ifndef UGUI_S1D15721_H
#define	UGUI_S1D15721_H

#include "hw.h"
#include "ugui.h"

#ifdef	__cplusplus
extern "C" {
#endif

    /* Set here your display resolution. */
#define DISPLAY_WIDTH           240
#define DISPLAY_HEIGHT          64

#define DIMENSION_X8            ((DISPLAY_WIDTH*DISPLAY_HEIGHT)/8)
#define DIMENSION_X4            ((DISPLAY_WIDTH*DISPLAY_HEIGHT)/4)    
//#define DISPLAY_PAGES           ( DISPLAY_HEIGHT/8 )
#define LCD_BYTE_WIDTH          ( DISPLAY_WIDTH/8 )
    // ### Commands
#define LCD_CMD_DATA_WRITE          0x1D    // Display Data Write (n-bytes)
#define LCD_CMD_PAGE_ADDR           0xB1    // Page Address Set (2 byte)
#define LCD_CMD_COL_ADDR            0x13    // Column Address Set (2 byte)
#define LCD_CMD_DISPLAY_OFFON       0xAE    // Display ON/OFF: 0=Off/1=On
#define LCD_CMD_DISPLAY_REVERSE     0xA6    // Display/Normal: 0=Normal/1=Reverse
#define LCD_CMD_DISPLAY_ALL_LIGHT   0xA4    // Display All Lighting: 0=Normal/1=All On
#define LCD_CMD_DISPLAY_START_LINE  0x8A    // Display Start Line (2/3 byte)
#define LCD_CMD_DISPLAY_MODE        0x66    // Display Mode (2 byte): 0=4 gray-scale, 1=binary
#define LCD_CMD_GRAY_SCALE_PATTERN  0x39    // Gray Scale Pattern (2 byte)
#define LCD_CMD_COM_OUT_STATUS      0xC4    // Common Output Status Select: 0=Normal/1=Reverse
#define LCD_CMD_DUTY_SET            0x6D    // Duty Set Command (3 byte)
#define LCD_CMD_BUILTIN_OSC         0xAA    // Built-in Oscillator Circuit: [0]:0=Off/1=On
#define LCD_CMD_BUILTIN_OSC_FREQ    0x5F    // Built-in Oscillator Circuit Frequency Select (2 byte)
#define LCD_CMD_PWR_CONTROL         0x25    // Power Control Set (2 byte)
#define LCD_CMD_LC_DRIVE_VOLTAGE    0x2B    // Liquid Crystal Drive Voltage Select (2 byte)
#define LCD_CMD_EL_VOLUME           0x81    // Electronic Volume Set (2 byte)
#define LCD_CMD_RESET               0xE2    // Software Reset



/* *** Function prototypes. *** */
void Display_Init();

#ifdef	__cplusplus
}
#endif

#endif	/* UGUI_S1D15721_H */

