/* 
 * File:   vlcd_message.h
 * Author: Steffen Hofmann
 *
 * Created on 10. Dezember 2024, 22:17
 */

#ifndef VLCD_MESSAGE_H
#define	VLCD_MESSAGE_H

#ifdef	__cplusplus
extern "C" {
#endif

#define WAIT_FOREVER   0


typedef enum{

#ifndef NO_ERROR
  NO_ERROR = 0,                         ///< NO_ERROR
  I2C_ERROR_NONE = 0,             /* No Error */        
#endif
          
//
// --  I2C Bus ------------------- // -----------------------------------------
//
  I2C_COMMAND_ERROR               = 0x0700,
  I2C_BUS,                          ///< 0x0701 - I2C Bus Error  ( Hardwarefehler )
  I2C_ACK,                          ///< 0x0702 - I2C ACK Error  ( keine Antwort vom Slave )
  I2C_RACK,
  I2C_TRX_READ,                     ///< 0x0703 - I2C
  I2C_TRX_WRITE,
  I2C_TIMEOUT,                      ///< 0x0704 - I2C Timeout
  I2C_TIMEOUT_INT,
  I2C_TIMEOUT_RACK,
  I2C_START_ERROR,
  I2C_OVERRUN_ERROR,
  I2C_WRITE,
  I2C_READ, 
  I2C_STOP,

  BUS_BESETZT,           //- Busy durch anderen Teilnehmer belegt
  NO_MESSWERT,           //- noch kein neuer Messwert beim externen Sensor vorhanden
  I2C_ERROR,             //- Baustein evtl. nicht vorhanden

  
  I2C_ERROR_ADDR_NACK,        /* Address Not Acknowledged */
  I2C_ERROR_DATA_NACK,        /* Data Not Acknowledged */
  I2C_ERROR_BUS_COLLISION,    /* Bus Collision Error */
  I2C_ERROR_BUSY,              /* I2C Host is busy */
          
//
// --  AHT20 Sensor ------------------- // ---------------------------------
//  
  AHT20_CMD_ERROR                  = 0x0A00,
  AHT20_CMD_CAL,
  AHT20_RST_REG_FAIL,
  AHT20_CRC,
  AHT20_DATA_NOT_READY,
  AHT20_NOT_INIT,
  AHT20_NOT_CONNECTED,
  AHT20_NOT_CAL,
  AHT20_NOT_BUSY,
  AHT20_NOT_AVAILABLE,
//
// --  AHT20 Sensor ------------------- // ---------------------------------
//  
  SENSOR_ERROR                  = 0x0B00,   //- kein Sensor gefunden !  
          
    
  MAX_ERROR_COUNT
}teErrorNumber;          
          
          


#ifdef	__cplusplus
}
#endif

#endif	/* VLCD_MESSAGE_H */

