/******************************************************************************
*                            Steffen Hofmann  shotech                         *
*                             mcu@shotech.de                                  *
*******************************************************************************
*  $Source:  $
*-----------------------------------------------------------------------------*
*  Datum der 2. Version  :  08.04.2023
*  Geraete Bezeichnung   :  vlcd
*-----------------------------------------------------------------------------*
*- $Id:  $
*-----------------------------------------------------------------------------*
*
*	Sourcefile
*	----------
*	SPI0
* 
*
******************************************************************************/

//#include <avr/io.h>
#include "vlcd_spi.h"
#include "hw.h"

void SPI0_init(void)
{
    /* SPI in host mode setting */
    PORTA.PIN7CTRL |= PORT_PULLUPEN_bm; /* Pull-up enable on PIN7 */
    PORTA.OUTSET = PIN7_bm;             /* Set SS pin to high state */
    //PORTD.OUTSET = PIN7_bm;             // CS Flash High
    //PORTD.DIRSET = PIN7_bm;             // PIN 7 CS-Flash Output
    PORTA.DIRSET = PIN4_bm;             /* Set MOSI pin direction to output */
    PORTA.DIRCLR = PIN5_bm;             /* Set MISO pin direction to input */
    PORTA.DIRSET = PIN6_bm;             /* Set SCK pin direction to output */
    PORTA.DIRSET = PIN7_bm;             /* Set SS pin direction to output */
    
    //PORTA.OUTSET = PIN2_bm;             // RST BU8793
    //PORTA.DIRSET = PIN2_bm;
    
    /* SPI Clock speed is set to 2 x 4MHz / 16 = 500 kHz */
    SPI0.CTRLB = SPI_MODE_3_gc | SPI_SSD_bm;
    SPI0.CTRLA = SPI_CLK2X_bm           /* Enable double-speed */
               | SPI_ENABLE_bm          /* Enable module */
               | SPI_MASTER_bm          /* SPI module in Host mode */
               | SPI_PRESC_DIV16_gc;    /* System Clock divided by 16 */
}

uint8_t SPI0_exchangeData(uint8_t sent_data)
{
    SPI0.DATA = sent_data;
    while (!(SPI0.INTFLAGS & SPI_IF_bm));  /* waits until data is exchanged */

    return SPI0.DATA;
}




